/*
 * Device tables.  See the Configure file for a complete description.
 */

#include <stdio.h>
#include "msdos.h"

#ifdef PC98
# ifndef MULTISECTORSIZE
		error!!
# endif
int	msector_size;

static set512sec()
{
	MSECTOR_SIZE = 512;
	return 0;
}

static set1024sec()
{
	MSECTOR_SIZE = 1024;
	return 0;
}
#endif

#ifdef DELL
struct device devices[] = {
	{'A', "/dev/rdsk/f0d9dt", 0L, 12, 0, (int (*) ()) 0, 40, 2, 9},
	{'A', "/dev/rdsk/f0q15dt", 0L, 12, 0, (int (*) ()) 0, 80, 2, 15},
	{'A', "/dev/rdsk/f0d8dt", 0L, 12, 0, (int (*) ()) 0, 40, 2, 8},
	{'B', "/dev/rdsk/f13ht", 0L, 12, 0, (int (*) ()) 0, 80, 2, 18},
	{'B', "/dev/rdsk/f13dt", 0L, 12, 0, (int (*) ()) 0, 80, 2, 9},
	{'C', "/dev/rdsk/dos", 0L, 16, 0, (int (*) ()) 0, 0, 0, 0},
	{'\0', (char *) NULL, 0L, 0, 0, (int (*) ()) 0, 0, 0, 0}
};
#endif /* DELL */

#ifdef ISC
struct device devices[] = {
	{'A', "/dev/rdsk/f0d9dt", 0L, 12, 0, (int (*) ()) 0, 40, 2, 9},
	{'A', "/dev/rdsk/f0q15dt", 0L, 12, 0, (int (*) ()) 0, 80, 2, 15},
	{'A', "/dev/rdsk/f0d8dt", 0L, 12, 0, (int (*) ()) 0, 40, 2, 8},
	{'B', "/dev/rdsk/f13ht", 0L, 12, 0, (int (*) ()) 0, 80, 2, 18},
	{'B', "/dev/rdsk/f13dt", 0L, 12, 0, (int (*) ()) 0, 80, 2, 9},
	{'C', "/dev/rdsk/0p1", 0L, 16, 0, (int (*) ()) 0, 0, 0, 0},
	{'D', "/usr/vpix/defaults/C:", 8704L, 12, 0, (int (*) ()) 0, 0, 0, 0},
	{'E', "$HOME/vpix/C:", 8704L, 12, 0, (int (*) ()) 0, 0, 0, 0},
	{'\0', (char *) NULL, 0L, 0, 0, (int (*) ()) 0, 0, 0, 0}
};
#endif /* ISC */

#ifdef SPARC
struct device devices[] = {
	{'A', "/dev/rfd0c", 0L, 12, 0, (int (*) ()) 0, 80, 2, 18},
	{'A', "/dev/rfd0c", 0L, 12, 0, (int (*) ()) 0, 80, 2, 9},
	{'\0', (char *) NULL, 0L, 0, 0, (int (*) ()) 0, 0, 0, 0}
};
#endif /* SPARC */
#ifdef RT_ACIS
struct device devices[] = {
      {'A', "/dev/rfd0", 0L, 12, 0, (int (*) ()) 0, 80, 2, 15},
      {'A', "/dev/rfd0", 0L, 12, 0, (int (*) ()) 0, 40, 2, 9},
      {'\0', (char *) NULL, 0L, 0, 0, (int (*) ()) 0, 0, 0, 0}
};
#endif /* RT_ACIS */


#ifdef UNIXPC
#include <sys/gdioctl.h>
#include <fcntl.h>

int init_unixpc();

struct device devices[] = {
	{'A', "/dev/rfp020", 0L, 12, O_NDELAY, init_unixpc, 40, 2, 9},
	{'C', "/usr/bin/DOS/dvd000", 0L, 12, 0, (int (*) ()) 0, 0, 0, 0},
	{'\0', (char *) NULL, 0L, 0, 0, (int (*) ()) 0, 0, 0, 0}
};

int
init_unixpc(fd, ntracks, nheads, nsect)
int fd, ntracks, nheads, nsect;
{
	struct gdctl gdbuf;

	if (ioctl(fd, GDGETA, &gdbuf) == -1) {
		ioctl(fd, GDDISMNT, &gdbuf);
		return(1);
	}

	gdbuf.params.cyls = ntracks;
	gdbuf.params.heads = nheads;
	gdbuf.params.psectrk = nsect;

	gdbuf.params.pseccyl = gdbuf.params.psectrk * gdbuf.params.heads;
	gdbuf.params.flags = 1;		/* disk type flag */
	gdbuf.params.step = 0;		/* step rate for controller */
	gdbuf.params.sectorsz = 512;	/* sector size */

	if (ioctl(fd, GDSETA, &gdbuf) < 0) {
		ioctl(fd, GDDISMNT, &gdbuf);
		return(1);
	}
	return(0);
}
#endif /* UNIXPC */

#ifdef RT_ACIS
struct device devices[] = {
	{'A', "/dev/rfd0", 0L, 12, 0, (int (*) ()) 0, 80, 2, 15},
	{'A', "/dev/rfd0", 0L, 12, 0, (int (*) ()) 0, 40, 2, 9},
	{'\0', (char *) NULL, 0L, 0, 0, (int (*) ()) 0, 0, 0, 0}
};
#endif /* RT_ACIS */

#ifdef SUN386
struct device devices[] = {
	{'A', "/dev/rfdl0c", 0L, 12, 0, (int (*) ()) 0, 80, 2, 9},
	{'A', "/dev/rfd0c", 0L, 12, 0, (int (*) ()) 0, 80, 2, 18},
	{'\0', (char *) NULL, 0L, 0, 0, (int (*) ()) 0, 0, 0, 0}
};
#endif /* SUN386 */

  
#ifdef SPARC_ODD
#include <sys/types.h>
#include <sun/dkio.h>
#include <fcntl.h>

int init_sparc();

struct device devices[] = {
	{'A', "/dev/rfd0c", 0L, 12, 0, init_sparc, 80, 2, 0},
	{'\0', (char *) NULL, 0L, 0, 0, (int (*) ()) 0, 0, 0, 0}
};

/*
 * Stuffing back the floppy parameters into the driver allows for gems
 * like 10 sector or single sided floppies from Atari ST systems.
 * 
 * Martin Schulz, Universite de Moncton, N.B., Canada, March 11, 1991.
 */

int
init_sparc(fd, ntracks, nheads, nsect)
int fd, ntracks, nheads, nsect;
{
	struct fdk_char dkbuf;
	struct dk_map   dkmap;

	if (ioctl(fd, FDKIOGCHAR, &dkbuf) != 0) {
		ioctl(fd, FDKEJECT, NULL);
		return(1);
	}

	if (ioctl(fd, DKIOCGPART, &dkmap) != 0) {
		ioctl(fd, FDKEJECT, NULL);
		return(1);
	}

	if (ntracks)
		dkbuf.ncyl = ntracks;
	if (nheads)
		dkbuf.nhead = nheads;
	if (nsect)
		dkbuf.secptrack = nsect;

	if (ntracks && nheads && nsect )
		dkmap.dkl_nblk = ntracks * nheads * nsect;

	if (ioctl(fd, FDKIOSCHAR, &dkbuf) != 0) {
		ioctl(fd, FDKEJECT, NULL);
		return(1);
	}

	if (ioctl(fd, DKIOCSPART, &dkmap) != 0) {
		ioctl(fd, FDKEJECT, NULL);
		return(1);
	}
	return(0);
}
#endif /* SPARC_ODD */
  
#ifdef XENIX
struct device devices[] = {
	{'A', "/dev/fd096ds15", 0L, 12, 0, (int (*) ()) 0, 80, 2, 15},
	{'A', "/dev/fd048ds9", 0L, 12, 0, (int (*) ()) 0, 40, 2, 9},
	{'B', "/dev/fd1135ds18", 0L, 12, 0, (int (*) ()) 0, 80, 2, 18},
	{'B', "/dev/fd1135ds9", 0L, 12, 0, (int (*) ()) 0, 80, 2, 9},
	{'C', "/dev/hd0d", 0L, 16, 0, (int (*) ()) 0, 0, 0, 0},
	{'\0', (char *) NULL, 0L, 0, 0, (int (*) ()) 0, 0, 0, 0}
};
#endif /* XENIX */

#ifdef __FreeBSD__

#ifdef PC98
struct device devices[] = {
#ifdef AB_MODE
	{'A', "/dev/rfd0.1200", 0L, 12, 0, set512sec, 80, 2, 15}, /* 1.2m */
	{'A', "/dev/rfd0.1232", 0L, 12, 0, set1024sec, 77, 2, 8}, /* 1.232m */
	{'A', "/dev/rfd0.1440", 0L, 12, 0, set512sec, 80, 2, 18}, /* 1.44m */
	{'A', "/dev/rfd0.720", 0L, 12, 0, set512sec, 80, 2, 9},  /* 720k */
	{'A', "/dev/rfd0.640", 0L, 12, 0, set512sec, 80, 2, 8},  /* 640k */
	{'B', "/dev/rfd1.1200", 0L, 12, 0, set512sec, 80, 2, 15}, /* 1.2m */
	{'B', "/dev/rfd1.1232", 0L, 12, 0, set1024sec, 77, 2, 8}, /* 1.232m */
	{'B', "/dev/rfd1.1440", 0L, 12, 0, set512sec, 80, 2, 18}, /* 1.44m */
	{'B', "/dev/rfd1.720", 0L, 12, 0, set512sec, 80, 2, 9},  /* 720k */
	{'B', "/dev/rfd1.640", 0L, 12, 0, set512sec, 80, 2, 8},  /* 640k */
	{'C', "/dev/rfd2.1200", 0L, 12, 0, set512sec,  80, 2, 15}, /* 1.2m */
	{'C', "/dev/rfd2.1232", 0L, 12, 0, set1024sec, 77, 2, 8},  /* 2HD */
	{'C', "/dev/rfd2.720", 0L, 12, 0, set512sec,  80, 2, 9},  /* 720k */
	{'D', "/dev/rfd3.1200", 0L, 12, 0, set512sec,  80, 2, 15}, /* 1.2m */
	{'D', "/dev/rfd3.1232", 0L, 12, 0, set1024sec, 77, 2, 8},  /* 2HD */
	{'D', "/dev/rfd3.720", 0L, 12, 0, set512sec,  80, 2, 9},  /* 720k */
#else
	{'A', "/dev/rfd0.1200", 0L, 12, 0, set512sec,  80, 2, 15}, /* 1.2m */
	{'C', "/dev/rfd0.1232", 0L, 12, 0, set1024sec, 77, 2, 8},  /* 2HD */
	{'*', "/dev/rfd0.1440", 0L, 12, 0, set512sec, 80, 2, 18}, /* 1.44m */
	{'E', "/dev/rfd0.720", 0L, 12, 0, set512sec,  80, 2, 9},  /* 720k */
	{'*', "/dev/rfd0.640", 0L, 12, 0, set512sec, 80, 2, 8},  /* 640k */
	{'B', "/dev/rfd1.1200", 0L, 12, 0, set512sec,  80, 2, 15}, /* 1.2m */
	{'D', "/dev/rfd1.1232", 0L, 12, 0, set1024sec, 77, 2, 8},  /* 2HD */
	{'*', "/dev/rfd1.1440", 0L, 12, 0, set512sec, 80, 2, 18}, /* 1.44m */
	{'F', "/dev/rfd1.720", 0L, 12, 0, set512sec,  80, 2, 9},  /* 720k */
	{'*', "/dev/rfd1.640", 0L, 12, 0, set512sec, 80, 2, 8},  /* 640k */
	{'G', "/dev/rfd2.1200", 0L, 12, 0, set512sec,  80, 2, 15}, /* 1.2m */
	{'I', "/dev/rfd2.1232", 0L, 12, 0, set1024sec, 77, 2, 8},  /* 2HD */
	{'K', "/dev/rfd2.720", 0L, 12, 0, set512sec,  80, 2, 9},  /* 720k */
	{'H', "/dev/rfd3.1200", 0L, 12, 0, set512sec,  80, 2, 15}, /* 1.2m */
	{'J', "/dev/rfd3.1232", 0L, 12, 0, set1024sec, 77, 2, 8},  /* 2HD */
	{'L', "/dev/rfd3.720", 0L, 12, 0, set512sec,  80, 2, 9},  /* 720k */
#endif
	{'M', "/dev/rsd0", 0L, 16, 0, set512sec, 9952, 1, 25}, /* 3.5in MO */
	{'N', "/dev/rsd1", 0L, 16, 0, set512sec, 9952, 1, 25}, /* 3.5in MO */
	{'O', "/dev/rsd2", 0L, 16, 0, set512sec, 9952, 1, 25}, /* 3.5in MO */
	{'P', "/dev/rsd3", 0L, 16, 0, set512sec, 9952, 1, 25}, /* 3.5in MO */
	{'Q', "/dev/rsd4", 0L, 16, 0, set512sec, 9952, 1, 25}, /* 3.5in MO */
	{'R', "/dev/rsd5", 0L, 16, 0, set512sec, 9952, 1, 25}, /* 3.5in MO */
	{'S', "/dev/rsd6", 0L, 16, 0, set512sec, 9952, 1, 25}, /* 3.5in MO */
	{'\0', (char *) NULL, 0L, 0, 0, (int (*) ()) 0, 0, 0, 0}
};
#else
struct device devices[] = {
        {'A', "/dev/rfd0.1440", 0L, 12, 0, (int (*) ()) 0, 80, 2, 18}, /* 1.44m */
        {'A', "/dev/rfd0.720", 0L, 12, 0, (int (*) ()) 0, 80, 2, 9},  /* 720k */
        {'A', "/dev/rfd0.1720", 0L, 12, 0, (int (*) ()) 0, 82, 2, 21},  /* 1.72mk */
        {'A', "/dev/rfd0.1480", 0L, 12, 0, (int (*) ()) 0, 82, 2, 18}, /* 1.44m */
        {'A', "/dev/rfd0.1200", 0L, 12, 0, (int (*) ()) 0, 80, 2, 15}, /* 1.2m */
        {'A', "/dev/rfd0.360", 0L, 12, 0, (int (*) ()) 0, 40, 2, 9},  /* 360k */
        {'B', "/dev/rfd1.1200", 0L, 12, 0, (int (*) ()) 0, 80, 2, 15}, /* 1.2m */
        {'B', "/dev/rfd1.1440", 0L, 12, 0, (int (*) ()) 0, 80, 2, 18}, /* 1.44m */
        {'B', "/dev/rfd1.720", 0L, 12, 0, (int (*) ()) 0, 80, 2, 9},  /* 720k */
        {'B', "/dev/rfd1.360", 0L, 12, 0, (int (*) ()) 0, 40, 2, 9},  /* 360k */
        {'B', "/dev/rfd1.1720", 0L, 12, 0, (int (*) ()) 0, 82, 2, 21},  /* 1.72mk */
        {'B', "/dev/rfd1.1480", 0L, 12, 0, (int (*) ()) 0, 82, 2, 18}, /* 1.44m */
        {'\0', (char *) NULL, 0L, 0, 0, (int (*) ()) 0, 0, 0, 0}
};
#endif /* PC98 */
#endif /* __FreeBSD__ */

#ifdef X68k
struct device devices[] = {
	{'A', "/dev/rfd0a", 0L, 12, 0, set1024sec, 77, 2,  8}, /* 1.232m(98)   */
	{'A', "/dev/rfd0b", 0L, 12, 0, set512sec , 80, 2, 18}, /* 1.44m        */
	{'A', "/dev/rfd0c", 0L, 12, 0, set512sec , 80, 2, 15}, /* 1.2m(AT)     */
	{'A', "/dev/rfd0d", 0L, 12, 0, set512sec , 80, 2,  9}, /* 360k in 1.2M */
	{'A', "/dev/rfd0e", 0L, 12, 0, set512sec , 80, 2,  9}, /* 360k in PC   */
	{'A', "/dev/rfd0f", 0L, 12, 0, set512sec , 80, 2,  9}, /* 720k         */
	{'A', "/dev/rfd0g", 0L, 12, 0, set512sec , 80, 2,  9}, /* 720k in 1.2M */
	{'A', "/dev/rfd0h", 0L, 12, 0, set512sec , 80, 2,  8}, /* 720k in 720k */

	{'B', "/dev/rfd1a", 0L, 12, 0, set1024sec, 77, 2,  8}, /* 1.232m(98)   */
	{'B', "/dev/rfd1b", 0L, 12, 0, set512sec , 80, 2, 18}, /* 1.44m        */
	{'B', "/dev/rfd1c", 0L, 12, 0, set512sec , 80, 2, 15}, /* 1.2m(AT)     */
	{'B', "/dev/rfd1d", 0L, 12, 0, set512sec , 80, 2,  9}, /* 360k in 1.2M */
	{'B', "/dev/rfd1e", 0L, 12, 0, set512sec , 80, 2,  9}, /* 360k in PC   */
	{'B', "/dev/rfd1f", 0L, 12, 0, set512sec , 80, 2,  9}, /* 720k         */
	{'B', "/dev/rfd1g", 0L, 12, 0, set512sec , 80, 2,  9}, /* 720k in 1.2M */
	{'B', "/dev/rfd1h", 0L, 12, 0, set512sec , 80, 2,  8}, /* 720k in 720k */

	{'C', "/dev/rfd2a", 0L, 12, 0, set1024sec, 77, 2,  8}, /* 1.232m(98)   */
	{'C', "/dev/rfd2b", 0L, 12, 0, set512sec , 80, 2, 18}, /* 1.44m        */
	{'C', "/dev/rfd2c", 0L, 12, 0, set512sec , 80, 2, 15}, /* 1.2m(AT)     */
	{'C', "/dev/rfd2d", 0L, 12, 0, set512sec , 80, 2,  9}, /* 360k in 1.2M */
	{'C', "/dev/rfd2e", 0L, 12, 0, set512sec , 80, 2,  9}, /* 360k in PC   */
	{'C', "/dev/rfd2f", 0L, 12, 0, set512sec , 80, 2,  9}, /* 720k         */
	{'C', "/dev/rfd2g", 0L, 12, 0, set512sec , 80, 2,  9}, /* 720k in 1.2M */
	{'C', "/dev/rfd2h", 0L, 12, 0, set512sec , 80, 2,  8}, /* 720k in 720k */

	{'D', "/dev/rfd3a", 0L, 12, 0, set1024sec, 77, 2,  8}, /* 1.232m(98)   */
	{'D', "/dev/rfd3b", 0L, 12, 0, set512sec , 80, 2, 18}, /* 1.44m        */
	{'D', "/dev/rfd3c", 0L, 12, 0, set512sec , 80, 2, 15}, /* 1.2m(AT)     */
	{'D', "/dev/rfd3d", 0L, 12, 0, set512sec , 80, 2,  9}, /* 360k in 1.2M */
	{'D', "/dev/rfd3e", 0L, 12, 0, set512sec , 80, 2,  9}, /* 360k in PC   */
	{'D', "/dev/rfd3f", 0L, 12, 0, set512sec , 80, 2,  9}, /* 720k         */
	{'D', "/dev/rfd3g", 0L, 12, 0, set512sec , 80, 2,  9}, /* 720k in 1.2M */
	{'D', "/dev/rfd3h", 0L, 12, 0, set512sec , 80, 2,  8}, /* 720k in 720k */

	{'\0', (char *) NULL, 0L, 0, 0, (int (*) ()) 0, 0, 0, 0}
};
#endif
